import sys
from datetime import datetime

import trace

def main(args=sys.argv):
    total = len(args) - 1
    fmt = "[%%%dd/%d]" % (len(str(total)), total)
    for i, fname in enumerate(sorted(args[1:])):
        try:
            print ("\n" + fmt + " %s") % (i + 1, fname)
            print "Start: %s" % datetime.now()
            sys.stdout.flush()
            trace.experiment(fname)
            print "End:   %s" % datetime.now()

        except (OSError, IOError) as msg:
            print 'Failed: %s\n%s' % (fname, msg)
        except KeyboardInterrupt:
            print 'Aborted.'
            return


if __name__ == '__main__':
    main()

